#include<Rcpp.h>
// [[Rcpp::depends(RcppParallel)]]
#include <RcppParallel.h>

struct My_Foo : RcppParallel::Worker{
    // member variables
    const RcppParallel::RVector<double> input;
    RcppParallel::RVector<double> output;
    
    // constructor
    My_Foo(Rcpp::NumericVector x, Rcpp::NumericVector y) : input(x), output(y) {}
    
    // operator functions
    void operator()(std::size_t start, std::size_t end){
        std::transform(input.begin() + start, 
                       input.begin() + end, 
                       output.begin() + start, 
                       sqrt);
    }
};
// [[Rcpp::export]]
Rcpp::NumericVector par_sqrt(Rcpp::NumericVector invec){
    Rcpp::NumericVector outvec(invec.size());
    My_Foo my_sqrt(invec, outvec);
    RcppParallel::parallelFor(0, invec.size(), my_sqrt);
    return(outvec);
}

// [[Rcpp::export]]
Rcpp::NumericVector rcpp_sqrt(Rcpp::NumericVector invec){
    Rcpp::NumericVector outvec(invec.size());
    std::transform(invec.begin(), invec.end(), outvec.begin(), sqrt);
    return(outvec);
}