#include<Rcpp.h>
// [[Rcpp::depends(RcppParallel)]]
#include <RcppParallel.h>

struct My_Sum : RcppParallel::Worker{
    // member variables
    const RcppParallel::RVector<double> input;
    double res;
    
    // constructor
    My_Sum(Rcpp::NumericVector x) : input(x), res(0.0) {}
    My_Sum(const My_Sum& my_sum, RcppParallel::Split): input(my_sum.input), res(0.0) {}
    // operator functions
    void operator()(std::size_t start, std::size_t end){
        res += std::accumulate(input.begin() + start, 
                               input.begin() + end, 
                               0.0);
    }
    void join(const My_Sum& rhs){
        res += rhs.res;
    }
};
// [[Rcpp::export]]
double par_sum(Rcpp::NumericVector invec){
    My_Sum my_sum(invec);
    RcppParallel::parallelReduce(0, invec.size(), my_sum);
    return(my_sum.res);
}

// [[Rcpp::export]]
double rcpp_sum(Rcpp::NumericVector invec){
    double res;
    res = std::accumulate(invec.begin(), invec.end(), 0.0);
    return(res);
}